#include "mbed.h"
#include "2l5v1a.h"

extern DigitalOut gr1_tx;
extern DigitalOut gr1_rx;

extern DigitalOut gr2_tx;
extern DigitalOut gr2_rx;

extern Serial pc;
//extern Serial servo_L;
extern Serial servo_R;

void move_servo(Serial *port, unsigned int servo_id, unsigned int data, unsigned int *return_data)
{
    int data_H, data_L;

    servo_id = servo_id | 0x80;

    data_H = data / 128;
    data_L = data & 0x7f;

    //Change signal line direction.
    gr1_tx = 0;
    gr1_rx = 1;

    //Write ID
    while (!port->writeable());
    port->putc(servo_id);
    wait_us(8);

    //Write position data
    while (!port->writeable());
    port->putc(data_H);
    wait_us(8);

    while (!port->writeable());
    port->putc(data_L);
    wait_us(16);

    //Read return data.
    gr1_tx = 1;
    gr1_rx = 0;
    while (!port->readable());
    servo_id = port->getc();
    while (!port->readable());
    data_H = port->getc();
    while (!port->readable());
    data_L = port->getc();
    
    *return_data = data_H * 128 + data_L;
}

void read_servo(Serial *port, unsigned int servo_id, unsigned int data, unsigned int return_data[6])
{
    int i;

    servo_id = servo_id | 0xA0;

    //Change signal line direction.
    gr1_tx = 0;
    //gr2_tx = 0;
    gr1_rx = 1;
    //gr2_rx = 1;

    //Write ID
    while (!port->writeable());
    port->putc(servo_id);
    wait_us(10);

    //Write Sub command
    while (!port->writeable());
    port->putc(data);
    wait_us(10);

    wait_us(10);
    //Change signal line direction.
    gr1_tx = 1;
    //gr2_tx = 1;
    gr1_rx = 0;
    //gr2_rx = 0;

    //Read data.
    for(i = 0; i < 3; i++) {
        while (!port->readable());
        return_data[i] = port->getc();
    }
    wait_us(75);
}

